<?php
/*
** 99ko
** Jonathan Coulet
** j.coulet@gmail.com
** http://www.99ko.org
*/



/*
** Fonctions de parssage & formatage
*/



/*
** Réécrit une chaine en version URL
*/
function simplifie_chaine($chaine){
	$chaine = utf8_decode($chaine);
	$chaine = strtolower(strtr($chaine, utf8_decode('ÀÁÂÃÄÅàáâãäåÒÓÔÕÖØòóôõöøÈÉÊËèéêëÇçÌÍÎÏìíîïÙÚÛÜùúûüÿÑñ()[]\'"~$&%*@ç!?;,:/\^¨€{}<>|+.- _'),  'aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn    --      c  ---    e       ---'));
	$chaine = str_replace(' ', '', $chaine);
	$chaine = preg_replace('#-{2,}#', '-', $chaine);
	$chaine = trim($chaine,'-');
	return utf8_encode($chaine);
}
/*
** Formate une date US
*/
function formate_date($chaine, $format = '%d/%m/%Y à %Hh%M'){
	return strftime($format, strtotime($chaine)); 
}
/*
** Tronque une chaine
*/
function tronque_chaine($chaine, $longueur, $rajout = '...'){
	if(mb_strlen($chaine) > $longueur){
		$chaine = substr($chaine, 0, $longueur).$rajout;
	}
	return $chaine;
}



/*
** Fonctions utilitaires
*/



/*
** Retourne le sous tableau d'un tableau à 2 dimenssions dès que clé + valeur recherchées sont trouvées
*/
function extrait_array($tableau, $cle, $valeur){
	foreach($tableau as $k=>$v){
		if($v[$cle] == $valeur){
			return $tableau[$k];
		}
	}
	return false;
}
/*
** Retourne la clé max d'un tableau
*/
function max_cle_array($tableau){
	return max(array_keys($tableau));
}
/*
** Tri un tableau à 2 dimenssions
*/
function tri_array($tableau, $cle, $mode){
	if($mode == 'desc'){ $mode = SORT_DESC; }
	elseif($mode == 'asc'){ $mode = SORT_ASC; }
	elseif($mode == 'num'){ $mode = SORT_NUMERIC; }
	$temp = array();
	foreach($tableau as $k=>$v){
		$temp[$k] = $v[$cle];
	}
	array_multisort($temp, $mode, $tableau);
	return $tableau;
}
/*
** Remplace la clé d'un tableau à 2 dimenssions par la valeur de la clé recherchée
*/
function valeur_vers_cle($tableau, $cle){
	$temp = array();
	foreach($tableau as $k=>$v){
		$temp[$v[$cle]] = $v;
	}
	return $temp;
}
/*
** Extrait toutes les valeurs d'un tableau à 2 dimenssions par rapport à la clé ciblée
*/
function extrait_valeurs_array($tableau, $cle){
	$temp = array();
	foreach($tableau as $k=>$v){
		$temp[] = $v[$cle];
	}
	return $temp;
}
/*
** Fonction file_put_contents() améliorée
*/
function fp_contents($fichier, $content){
	if(!file_exists($fichier)){
		@fopen($fichier, 'w+', 0666);
	}
	@chmod($fichier, 0666);
	if(is_writable($fichier) && file_put_contents($fichier, $content)){
		return true;
	}
	return false;
}
/*
** Valide une adresse e-mail
*/
function valide_email($email){
	if(preg_match('/^[-a-z0-9!#$%&\'*+\\/=?^_`{|}~]+(\.[-a-z0-9!#$%&\'*+\\/=?^_`{|}~]+)*@(([a-z" .
"0-9]([-a-z0-9]*[a-z0-9]+)?){1,63}\.)+([a-z0-9]([-a-z0-9]*[a-z0-9]+)?){2,63}$/i', $email)){
		return true;
	}
	return false;
}



/*
** Fonctions liées au système de stockage
*/



/*
** Charge les données d'un ou de plusieurs fichiers dans un tableau
*/
function charge($chemin){
	$data = array();
	if(is_dir($chemin)){
		foreach(scandir($chemin) as $k=>$v){
			if($v[0] != '.' && $id = str_replace('.txt', '', $v)){
				preg_match_all('#\[(.*)\]#Usi', file_get_contents($chemin.$v), $matches);
				foreach($matches[1] as $k2=>$v2){
					$temp = explode('|', $v2);
					$data[$id][$temp[0]] = $temp[1];
				}
			}
		}
	}
	elseif(is_file($chemin)){
		preg_match_all('#\[(.*)\]#Usi', file_get_contents($chemin), $matches);
		foreach($matches[1] as $k=>$v){
			$temp = explode('|', $v);
			$data[$temp[0]] = $temp[1];
		}
	}
	return $data;
}

/*
** Enregistre les données d'un tableau ou d'un sous tableau dans un fichier
*/
function enregistre($tableau, $chemin, $cle = 0){
	$data = '';
	// tableau a 2 dimenssions
	if(isset($tableau[$cle])){
		foreach($tableau[$cle] as $k=>$v){
			$data .= "[".$k."|".$v."]\n";
		}
		if(fp_contents($chemin.$cle.'.txt', $data)){
			return true;
		}
	}
	// tableau simple
	elseif($cle != ''){
		foreach($tableau as $k=>$v){
			$data .= "[".$k."|".$v."]\n";
		}
		if(fp_contents($chemin.$cle.'.txt', $data)){
			return true;
		}
	}
	return false;
}
/*
** Remplace les caractères interdits dans les fichiers de données
*/
function remplace_caracteres_reserves($chaine){
	$a_recherche = array('|', '[', ']');
	$a_remplace = array('', '', '');
	return str_replace($a_recherche, $a_remplace, $chaine);
}



/*
** Fonctions spécifiques 99ko
*/



/*
** Place un jeton en session et le retourne
*/
function jeton($id_session = 'jeton1'){
	$token = sha1(uniqid());
	$_SESSION[$id_session] = $token;
	return $token;
}
/*
** Compare les jetons $_SESSION et $_GET
*/
function valide_jeton($id_get = 'jeton1', $id_session = 'jeton1'){
	if($_GET[$id_get] == $_SESSION[$id_session]){
		return true;
	}
	return false;
}
function get_config($fichier = 'data/config.txt'){
	$config = charge($fichier);
	if(!isset($config['email_admin'])){ $config['email_admin'] = ''; } // Depuis la 0.2
	if(!isset($config['mod_contact'])){ $config['mod_contact'] = 0; } // Depuis la 0.2
	if(!isset($config['mod_news_nb_last'])){ $config['mod_news_nb_last'] = 3; } // Depuis la 0.3
	if(!isset($config['sidebar'])){ $config['sidebar'] = 0; } // Depuis la 0.3.2
	return $config;
}
function get_news($dossier = 'data/news/'){
	$news = charge($dossier);
	$news = tri_array($news, 'date', 'desc');
	$news = valeur_vers_cle($news, 'id');
	return $news;
}
function get_pages($fichier = 'data/pages/'){
	$pages = charge($fichier);
	foreach($pages as $k=>$v){
		// Depuis la 0.3.1
		if(!isset($pages[$k]['etat'])){
			$pages[$k]['etat'] = 1;
		}
	}
	$pages = tri_array($pages, 'ordre', 'num');
	$pages = valeur_vers_cle($pages, 'id');
	return $pages;
}
function auto_header(){
	global $module, $modules;
	$cle = ($module == 'admin') ? 'admin_css' : 'front_css';
	foreach($modules as $k=>$v){
		if($v[$cle] != ''){
			echo '<link rel="stylesheet" type="text/css" media="screen" href="modules/'.$k.'/'.$v[$cle].'" />';
		}
	}
}
?>