<?php
session_start();
/*
** 99ko
** Jonathan Coulet
** j.coulet@gmail.com
** http://www.99ko.org


** Variables principales
** -------------------------------------------
** $temps_exe => résultat du temps d'execution du script
** $version => version de 99ko
** $config ( array ) => tableau des données de configuration
** $pages ( array ) => tableau de données des pages
** $module => module appelé ( $_GET[0] )
** $section => module admin appelé
** $meta_title = >meta title de la page
** $meta_desc => meta description de la page
** $menu_pages => ( bool ) permet de masquer / afficher le menu des pages
** $sidebar => ( bool ) permet de masquer / afficher la sidebar
** $template => fichier a inclure dans base.php
** $news ( array ) => tableau de données des news
** $modules (array) => tableau des modules chargés
*/

header('Content-type: text/html; charset=UTF-8');
$temps_exe = microtime(true);
include('99ko.lib.php');
$version = '0.4b';
if(!file_exists('data/config.txt')){
	header('location:install/');
	exit();
}

/*
** Fix
*/

setlocale(LC_TIME, 'fr_FR.utf8','fra');
// Magic quotes
if(get_magic_quotes_gpc()){
	function stripslashes_deep($value){
		$value = is_array($value) ? array_map('stripslashes_deep', $value) : stripslashes($value);
		return $value;
	}
	$_POST = array_map('stripslashes_deep', $_POST);
	$_GET = array_map('stripslashes_deep', $_GET);
	$_COOKIE = array_map('stripslashes_deep', $_COOKIE);
	$_REQUEST = array_map('stripslashes_deep', $_REQUEST);
}
if(get_magic_quotes_runtime()){
	set_magic_quotes_runtime(0);
}

/*
** Reconstruction de $_GET
*/
if($_SERVER['QUERY_STRING'] != ''){
	// Avant le premier slash = module
	$_GET[0] = substr($_SERVER['QUERY_STRING'], 0, strpos($_SERVER['QUERY_STRING'], '/'));
	// Les autres paramètres
	foreach(explode(',', substr($_SERVER['QUERY_STRING'], strpos($_SERVER['QUERY_STRING'], '/')+1)) as $k=>$v){
		if($v != ''){ $_GET[$k+1] = $v; }
	}
}

/*
** Données
*/
$config = get_config();
$pages = get_pages();
$news = get_news();

/*
** Execution du module
*/
$module = (isset($_GET[0])) ? $_GET[0] : 'page';
$modules = array();
// Chargement des modules externes + common
$module_mode = ($module != 'admin') ? 'front_common' : 'admin_common';
foreach(scandir('modules/') as $k=>$v) if($v[0] != '.' && is_dir('modules/'.$v)){
	include('modules/'.$v.'/'.$v.'.php');
}
if($module != 'admin'){
	$meta_title = $config['nom_site'];
	$meta_desc = $config['desc_site'];
	$menu_pages = true;
	$sidebar = ($config['sidebar'] > 0 || count($news) > 0) ? true : false;
	switch($module){
		case 'page':
			// Récupération de la page demandée ou de la homepage
			$page = (isset($_GET[1])) ? $pages[$_GET[1]] : extrait_array($pages, 'homepage', 1);
			if($page['etat'] > 0 || $page['homepage'] > 0){
				// Balises meta
				if($page['homepage'] == 0){
					$meta_title = $config['nom_site'].' - '.$page['nom'];
				}
				$template = 'page';
			}
			break;
		case 'contact':
			if($config['mod_contact'] == 1){
				$msg = "Tous les champs sont obligatoires.";
				if(count($_POST) > 0){
					$nom = trim($_POST['nom']);
					$email = trim($_POST['email']);
					$message = trim($_POST['message']);
					// Validation
					if(sha1($_POST['captcha_reponse']) != $_SESSION['captcha_reponse_sha1']){
						$msg = "La vérification antispam a échouée.";
					}
					elseif($nom == '' || $email == '' || $message == ''){
						$msg = "Tous les champs sont obligatoires.";
					}
					elseif(!valide_email($email)){
						$msg = "L'adresse e-mail est invalide.";
					}
					// Envoi
					else{
						$message = "Nom : ".$nom."\r\nE-mail : ".$email."\r\n\r\n"."Message : ".$message;
						$headers = "From: system@".$_SERVER['HTTP_HOST']."\r\n"; // Corrige un problème de mise en spam du message
						$headers .= "Reply-To: ".$email."\r\n";
						$headers .= "Return-Path: ".$email."\r\n";
						$headers .= "X-Mailer: PHP/".phpversion()."\r\n";
						$headers .= 'Content-Type: text/plain; charset="utf-8"'."\r\n";
						$headers .= 'Content-Transfer-Encoding: 8bit';
						if(!@mail($config['email_admin'], $config['nom_site'].' - Contact', $message, $headers)){
							$msg = "Le message n'a pas été envoyé car une erreur est survenue.";
						}
						else{
							$msg = "Le message a bien été envoyé.";
							// On vide $_POST
							$_POST = array();
						}
					}
				}
				// Captcha
				$captcha_a = rand(1,5);
				$captcha_b = rand(1,5);
				$_SESSION['captcha_reponse_sha1'] = sha1($captcha_a + $captcha_b);
				/// Meta
				$meta_title = $config['nom_site'].' - Contact';
				$template = 'contact';
			}
			break;
		case 'news':
			// Mode détail
			if(isset($_GET[1]) && isset($news[$_GET[1]])){
				$n = $news[$_GET[1]];
				// récupération des news : précédente et suivante
				reset($news);
				foreach($news as $k=>$v){
					if($k == $_GET[1]){
						break;
					}
					$n_suiv = $v;
				}
				$n_suiv = (isset($n_suiv)) ? $n_suiv : false;
				$n_prec = current($news);
				// Meta
				$meta_title = $config['nom_site'].' - '.$n['nom'];
			}
			// Mode archives
			else{
				$meta_title = $config['nom_site'].' - Archives des actualités';
			}
			$template = 'news';
			break;
	}
	// Execution module externe
	if(isset($modules[$module]) && $modules[$module]['front_template'] != ''){
		$module_mode = 'front_exe';
		include('modules/'.$modules[$module]['id'].'/'.$modules[$module]['id'].'.php');
		$template = 'modules/'.$modules[$module]['id'].'/'.$modules[$module]['front_template'];
	}
	// Fin
	$temps_exe = round(microtime(true)-$temps_exe, 3);
	include('themes/'.$config['theme'].'/base.php');
}
// Administration
else{
	$menu_pages = true;
	$sidebar = true;
	if(!isset($_SESSION['admin']) || $_SESSION['admin'] != $config['mdp_admin']){
		$section = 'login';
	}
	elseif(isset($_GET[1])){
		$section = $_GET[1];
	}
	elseif(count($modules) > 0){
		$section = 'modules';
	}
	else{
		$section = 'page';
	}
	$action = (isset($_GET[2])) ? $_GET[2] : '';
	switch($section){
		case 'msg':
			$jeton = jeton(); // Fix problème deconnexion
			$template = 'msg';
			break;
		case 'login':
			$msg = '';
			if($action == 'check' && valide_jeton(3)){
				if(sha1($_POST['mdp']) != $config['mdp_admin']){
					$msg = "Mot de passe incorrect.";
				}
				if($msg == ''){
					$_SESSION['admin'] = sha1($_POST['mdp']);
					header('location:?admin/');
					exit();
				}
			}
			$menu_pages = false;
			$sidebar = false;
			$jeton = jeton();
			$template = 'login';
			break;
		case 'exit':
			if(valide_jeton(2)){
				$_SESSION['admin'] = '';
				header('location:?page/');
				exit();
			}
			break;
		case 'page':
			if($action == 'save' && valide_jeton(3)){
				$msg = '';
				// Préparation des données
				$id = (intval($_POST['id']) > 0) ? intval($_POST['id']) : max_cle_array($pages)+1;
				$nom = trim(remplace_caracteres_reserves($_POST['nom']));
				$ordre = intval($_POST['ordre']);
				$homepage = (isset($_POST['homepage'])) ? 1 : ((!extrait_array($pages, 'homepage', 1)) ? 1 : 0); // Force homepage si aucunne n'existe déjà
				$contenu = trim(remplace_caracteres_reserves($_POST['contenu']));
				$etat = $_POST['etat'];
				// Contrôles
				if($nom == ''){
					$nom = "Page sans titre";
				}
				if($msg == ''){
					// Mise à jour de la homepage actuelle
					if($homepage == 1){
						$pagehome = extrait_array($pages, 'homepage', 1);
						if($pagehome['id'] != $id){
							$pages[$pagehome['id']]['homepage'] = 0;
							if(!enregistre($pages, 'data/pages/', $pagehome['id'])){
								$msg = "Une erreur d'écriture est survenue.";
							}
						}
					}
					if($msg == ''){
						// Mise à jour du tableau des pages
						$pages[$id] = array(
							'id' => $id,
							'nom' => $nom,
							'ordre' => $ordre,
							'homepage' => $homepage,
							'contenu' => $contenu,
							'etat' => $etat,
						);
						// Enregistrement
						if(!enregistre($pages, 'data/pages/', $id)){
							$msg = "Une erreur d'écriture est survenue.";
						}
						else{
							$msg = "Les modifications ont bien été enregistrées.";
						}
					}
				}
				// Redirection
				header('location:?admin/msg,'.urlencode($msg));
				exit();
			}
			elseif($action == 'del' && valide_jeton(4)){
				$page = $pages[$_GET[3]];
				if($page['homepage'] == 1){
					$msg = "Impossible de supprimer la page d'accueil.";
				}
				elseif(count($pages) < 2){
					$msg = "Impossible de supprimer l'unique page.";
				}
				if($msg == ''){
					if(unlink('data/pages/'.$page['id'].'.txt')){
						$msg = "Les modifications ont bien été enregistrées.";
					}
					else{
						$msg = "Une erreur d'écriture est survenue.";
					}
				}
				header('location:?admin/msg,'.urlencode($msg));
				exit();
			}
			elseif($action == 'changehome' && valide_jeton(4)){
				// Mise a zéro de toutes les valeurs homepage et enregistrement
				foreach($pages as $k=>$v) if($k != $_GET[3]){
					$pages[$k]['homepage'] = 0;
					if(!enregistre($pages, 'data/pages/', $k)){
						$msg = "Une erreur d'écriture est survenue.";
						header('location:?admin/msg,'.urlencode($msg));
						exit();
					}
				}
				// Nouvelle homepage
				$pages[$_GET[3]]['homepage'] = 1;
				if(!enregistre($pages, 'data/pages/', $_GET[3])){
					$msg = "Une erreur d'écriture est survenue.";
					header('location:?admin/msg,'.urlencode($msg));
					exit();
				}
				header('location:?admin/page');
				exit();
			}
			elseif($action == 'changeordre' && valide_jeton(5)){
				$pages[$_GET[3]]['ordre'] = intval($_GET[4]);
				if(!enregistre($pages, 'data/pages/', $_GET[3])){
					$msg = "Une erreur d'écriture est survenue.";
					header('location:?admin/msg,'.urlencode($msg));
					exit();
				}
				header('location:?admin/page');
				exit();
			}
			elseif($action == 'edit'){
				if(isset($_GET[3])){
					$page = $pages[$_GET[3]];
				}
				else{
					$ordre = max(extrait_valeurs_array($pages, 'ordre'))+1;
				}
				$jeton = jeton();
				$template = 'page_edit';
			}
			else{
				$infos_pages = array();
				foreach($pages as $k=>$v){
					$infos_pages[$k]['taille'] = round(filesize('data/pages/'.$k.'.txt')/1024, 2);
					$infos_pages[$k]['etat'] = ($v['etat'] == 1) ? 'en ligne' : (($v['etat'] == 0) ? 'hors-ligne' : 'fantôme');
				}
				$jeton = jeton();
				$template = 'page';
			}
			break;
		case 'config':
			if($action == 'save' && valide_jeton(3)){
				$msg = '';
				// Préparation des données
				$mdp_admin = (trim(remplace_caracteres_reserves($_POST['mdp_admin'])) != '') ? trim(remplace_caracteres_reserves($_POST['mdp_admin'])) : '';
				$mdp_admin_sha1 = ($mdp_admin == '') ? $config['mdp_admin'] : sha1($mdp_admin);
				$nom_site = trim(remplace_caracteres_reserves($_POST['nom_site']));
				$theme = $_POST['theme'];
				$desc_site = trim(remplace_caracteres_reserves($_POST['desc_site']));
				$mod_contact = (isset($_POST['mod_contact'])) ? 1 : 0;
				$email_admin = trim($_POST['email_admin']);
				$mod_news_nb_last = intval($_POST['mod_news_nb_last']);
				$force_sidebar = (isset($_POST['force_sidebar'])) ? 1 : 0;
				// Contrôles
				if($nom_site == ''){
					$msg = "Veuillez remplir les champs obligatoires.";
				}
				if($mdp_admin != '' && mb_strlen($mdp_admin) < 6){
					$msg = "Le mot de passe admin doit être composé de 6 caractères minimum.";
				}
				if($mod_contact == 1 && !valide_email($email_admin)){
					$msg = "Le formulaire de contact ne peut pas être activé car l'adresse e-mail administrateur est invalide.";
				}
				// Mise à jour du tableau $config
				$config['mdp_admin'] = $mdp_admin_sha1;
				$config['nom_site'] = $nom_site;
				$config['theme'] = $theme;
				$config['desc_site'] = $desc_site;
				$config['mod_contact'] = $mod_contact;
				$config['email_admin'] = $email_admin;
				$config['mod_news_nb_last'] = $mod_news_nb_last;
				$config['sidebar'] = $force_sidebar;
				// Fix : deconnection après changement du mot de passe
				$_SESSION['admin'] = $config['mdp_admin'];
				// Enregistrement
				if($msg == ''){
					if(!enregistre($config, 'data/', 'config')){
						$msg = "Une erreur d'écriture est survenue.";
					}
					else{
						$msg = "Les modifications ont bien été enregistrées.";
					}
				}
				// Redirection
				header('location:?admin/msg,'.urlencode($msg));
				exit();
			}
			$themes = array();
			foreach(scandir('themes/') as $k=>$v){
				if('themes/'.is_dir($v[0]) && $v[0] != '.'){
					$themes[] = $v;
				}
			}
			$jeton = jeton();
			$template = 'config';
			break;
		case 'news':
			if($action == 'save' && valide_jeton(3)){
				$msg = '';
				// Préparation des données
				$id = (intval($_POST['id']) > 0) ? intval($_POST['id']) : max_cle_array($news)+1;
				$nom = trim(remplace_caracteres_reserves($_POST['nom']));
				$contenu = trim(remplace_caracteres_reserves($_POST['contenu']));
				$date = $_POST['d_y'].'-'.$_POST['d_m'].'-'.$_POST['d_d'].' '.$_POST['d_h'].':'.$_POST['d_i'].':'.$_POST['d_s'];
				// Contrôles
				if($nom == ''){
					$nom = "Actualité sans titre";
				}
				if($msg == ''){
					if($msg == ''){
						// Mise à jour du tableau des news
						$news[$id] = array(
							'id' => $id,
							'nom' => $nom,
							'contenu' => $contenu,
							'date' => $date,
						);
						// Enregistrement
						if(!enregistre($news, 'data/news/', $id)){
							$msg = "Une erreur d'écriture est survenue.";
						}
						else{
							$msg = "Les modifications ont bien été enregistrées.";
						}
					}
				}
				// Redirection
				header('location:?admin/msg,'.urlencode($msg));
				exit();
			}
			elseif($action == 'del' && valide_jeton(4)){
				$n = $news[$_GET[3]];
				if(@unlink('data/news/'.$n['id'].'.txt')){
					$msg = "Les modifications ont bien été enregistrées.";
				}
				else{
					$msg = "Une erreur est survenue.";
				}
				header('location:?admin/msg,'.urlencode($msg));
				exit();
			}
			elseif($action == 'edit'){
				if(isset($_GET[3])){
					$n = $news[$_GET[3]];
					$date = preg_split('/[- :]/', $n['date']);
				}
				else{
					$date = preg_split('/[- :]/', date('Y-m-d H:i:s'));
				}
				$jeton = jeton();
				$template = 'news_edit';
			}
			else{
				$jeton = jeton();
				$template = 'news';
			}
			break;
		case 'modules':
			$jeton = jeton(); // Fix problème deconnexion
			$template = 'modules';
			break;
	}
	// Execution module externe
	if(isset($modules[$section]) && $modules[$section]['admin_template'] != ''){
		$module_mode = 'admin_exe';
		include('modules/'.$modules[$section]['id'].'/'.$modules[$section]['id'].'.php');
		$template = 'modules/'.$modules[$section]['id'].'/'.$modules[$section]['admin_template'];
	}
	// Fin
	$temps_exe = round(microtime(true)-$temps_exe, 3);
	include('admin/base.php');
}
?>